#include <qdebug.h>
#include "optics.h"
#include "ui_optics.h"

Optics::Optics(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::Optics)
{
    ui->setupUi(this);
    /*
     * hook up the actions to their code
     */

    connect(ui->actionQuit, SIGNAL(triggered()),this,SLOT(fileQuit()));
    connect(ui->a11, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->a12, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->a21, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->a22, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->optX, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->optAngle, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
}

Optics::~Optics()
{
    delete ui;
}
void Optics::fileQuit()
{
    QCoreApplication::quit();
}

void Optics::calculate()
{
    qDebug() << "Calculate" << endl;
    double m11,m12,m21,m22;
    double x,angle,newX,newAngle;
    m11 = (ui->a11) ->value();
    m12 = (ui->a12) ->value();
    m21 = (ui->a21) ->value();
    m22 = (ui->a22) ->value();
    x =     (ui->optX) ->value();
    angle = (ui->optAngle) ->value();

    qDebug() << m11 << " " << m12 << " " << m21 << " " << m22 << endl;
    newX = m11*x+m12*angle;
    newAngle = m21*x+m22*angle;
    QString dataString;
    dataString.sprintf("%f\n",newX);
    (ui->optNewX)->setText(dataString);
    dataString.sprintf("%f\n",newAngle);
    (ui->optNewAngle)->setText(dataString);
}
